/* StartAffinity 1.2.3 (c) 2004 Andrew Budd
 *	budda@budda.phpwebhosting.com
 *
 *	This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>

#define SET_BIT(var, bit)	((var) |= (bit))

int procs;

int main(int argc, char* argv[])
{
	if (argc < 3)
	{printf("\nStartAffinity 1.2.3: Written by Andrew Budd (Miros)  04-16-04\nArgument 1: App you wish to start\nArgument 2: Processor IDs, #( 0 - 31 supported)\n\nExample: StartAffinity notepad.exe 0 1\n\nwould start notepad.exe on processors 0 and 1.\n\n");exit(0);}
	
	printf("\nStartAffinity 1.2.3 by Andrew Budd (Miros) - budda@budda.phpwebhosting.com\n");

	int i;
	for (i=2; i<argc; i++)
		SET_BIT(procs, ( 1 << atoi(argv[i]) ) );

	char TitleBuf[1024];
	sprintf(TitleBuf,"Started by StartAffinity");
	//char errorbuf[1024];
	HANDLE hProcess;
	PROCESS_INFORMATION RunOnDesktopPI;
	STARTUPINFO RunOnDesktopSI; GetStartupInfo(&RunOnDesktopSI);
	RunOnDesktopSI.lpDesktop = "default";
	_snprintf(TitleBuf,255,"StartAffinity: %s",argv[1] );
	RunOnDesktopSI.lpTitle = TitleBuf;
	if (CreateProcess(NULL,argv[1],NULL,NULL,true,NULL,NULL,NULL,&RunOnDesktopSI,&RunOnDesktopPI))
	{
		hProcess = OpenProcess(MAXIMUM_ALLOWED,true,RunOnDesktopPI.dwProcessId);
		SetProcessAffinityMask(hProcess,procs);
/* Uncomment to debug
		_snprintf(errorbuf,1024,"%d",GetLastError());
		MessageBox(NULL,errorbuf,"Error",NULL);
*/ 
  }
	return GetLastError();
}
